#include "CoordSystem.h"


/*
 Constructor 
*/
M_CoordSystem::M_CoordSystem( float c, int Grid )
{
 c_size=c;
 a_cone= c_size / 10.;

 
 N_gridPoints = Grid;   

 Init_CoordSystem();
}

M_CoordSystem::~M_CoordSystem()
{
}

void
M_CoordSystem::Init_CoordSystem()
{
 Lim_3D[X_c][0]=-c_size/2;    Lim_3D[X_c][1]=c_size/2;
 Lim_3D[Y_c][0]=-c_size/2;    Lim_3D[Y_c][1]=c_size/2;
 Lim_3D[Z_c][0]= 0.0; /*-c_size/2*/     Lim_3D[Z_c][1]=c_size;
}

void
M_CoordSystem::get_gridStepAxis(float &kx, float &ky, float &kz)
{ 
   kx =  (Lim_3D[X_c][1]-Lim_3D[X_c][0]) / N_gridPoints;
   ky =  (Lim_3D[Y_c][1]-Lim_3D[Y_c][0]) / N_gridPoints;
   kz =  (Lim_3D[Z_c][1]-Lim_3D[Z_c][0]) / N_gridPoints;
 }

void
M_CoordSystem::get_PointfromGrid( int ix, int iy, int iz, float *res )
{

 /*
  The returned value must have been allocated
  prior to function's call. */
 
  float kx, ky, kz;
  get_gridStepAxis( kx, ky, kz); 

  res[0] = Lim_3D[X_c][0] + ix * kx;
  res[1] = Lim_3D[Y_c][0] + iy * ky;
  res[2] = Lim_3D[Z_c][0] + iz * kz;

}
