//
// Class for the definition of a coordinate system.
// This system is the same as internal's Inventor's
// system, that is X,Y plane is parallel to the image we
// see and Z axis is perpendicular coming out of the screen.
//

#define X_c 0
#define Y_c 1
#define Z_c 2


class M_CoordSystem {
 private:
   
   /* The limits of our coordinate system => cube */
   float Lim_3D[3][2];

   /* The size of the cube */
   float c_size;
   /* The diameter of each cone, initially */
   float a_cone;
   /* Grid Points per axis, used to sample our
      continuous cube of points.
   */
   int N_gridPoints;  // 5

   /* Define the coordinate system */
   void Init_CoordSystem(void);

   public:
    M_CoordSystem(float  c = 100. ,
                  int Grid = 5);
   
   ~M_CoordSystem();
/*
    float (*Lim)[2] get_Limits() const {
                    return Lim_3D;
		    }
*/
 
   float get_c() const { return c_size; }
    float get_a() const { return a_cone; }

    int get_gridPtsAxis() const { return N_gridPoints; }
    int get_gridPtsTotal() const { return N_gridPoints * N_gridPoints
                                          * N_gridPoints ; }
    void get_gridStepAxis( float &, float &, float &);
    
    void get_PointfromGrid(int, int, int, float *);

}; /* End class's definition */    
   
  

