#ifndef _MODEL_INV_PTS
#define _MODEL_INV_PTS
class SoSeparator;
class SoSelection;
class SoTransform;
class SoMaterial;
class SoSensor;
class SoNodeSensor;
class SoPointSet;
class SoNormal;
class SoShapeHints;
class SoCoordinate3;
class SoNormalBinding;
class SoLineSet;


class Model{
private:
 SoSeparator   *ModelRoot;

 SoSeparator   *TotalRoot;
 SoTransform   *ModelTransf;
 SoMaterial    *Material;

 SoPointSet *pts_facet;
 SoLineSet *lns_set;
 SoCoordinate3 *coord3;


 int _total_num_points;


public:
 Model();

 // SoSelection
 SoSeparator *getRoot()const { return TotalRoot; };
 void addPoints(float Vertices[][3], int numVertices);

 void RandomColor();
 void setColor(double r, double g, double b);
 //Use those routines only whwn you are adding individual points
 void addOnePoint(float onePoint[3]);
 void StartOfModel();
 void EndOfModel();
 //---


 static void translationChangedCB( void * data, SoSensor *s);
 static void rotationChangedCB( void * data, SoSensor *s);

};

#endif
